CREATE TABLE JCR_CONTAINER(
  VERSION VARCHAR(255) NOT NULL PRIMARY KEY
  );
CREATE TABLE JCR_MITEM(
	ID VARCHAR(255) NOT NULL PRIMARY KEY, 
	VERSION INTEGER NOT NULL, 
	PATH VARCHAR(1024) NOT NULL
	);
CREATE INDEX JCR_IDX_MITEM_PATH ON JCR_MITEM(PATH);
CREATE TABLE JCR_MNODE(
	ID VARCHAR(255) NOT NULL PRIMARY KEY, 
	ORDER_NUM INTEGER, 
	PARENT_ID VARCHAR(255), 
	CONSTRAINT JCR_FK_MNODE_PARENT FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID), 
	CONSTRAINT JCR_FK_MNODE_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID)
	);
CREATE INDEX JCR_IDX_MNODE_PARENT ON JCR_MNODE(ID, PARENT_ID, ORDER_NUM);
CREATE TABLE JCR_MPROPERTY(
	ID VARCHAR(255) NOT NULL PRIMARY KEY,
	TYPE INTEGER NOT NULL, 
	PARENT_ID VARCHAR(255) NOT NULL, 
	MULTIVALUED BOOLEAN NOT NULL, 
	CONSTRAINT JCR_FK_MPROPERTY_NODE FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID), 
	CONSTRAINT JCR_FK_MPROPERTY_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID) 
	);
CREATE INDEX JCR_IDX_MPROPERTY_PARENT ON JCR_MPROPERTY(ID, PARENT_ID);
CREATE INDEX JCR_IDX_MPROPERTY_TYPE ON JCR_MPROPERTY(ID, TYPE);
CREATE TABLE JCR_MVALUE(
	ID BIGINT generated by default as identity (START WITH 2, INCREMENT BY 1) NOT NULL PRIMARY KEY, 
	DATA VARBINARY(65535) NOT NULL, 
	ORDER_NUM INTEGER, 
	PROPERTY_ID VARCHAR(255) NOT NULL, 
	CONSTRAINT JCR_FK_MVALUE_PROPERTY FOREIGN KEY(PROPERTY_ID) REFERENCES JCR_MPROPERTY(ID)
	);
CREATE INDEX JCR_IDX_MVALUE_PROPERTY ON JCR_MVALUE(PROPERTY_ID, ORDER_NUM);	